

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#if defined(_WIN32) || defined(__GNUC__)
	#include <iostream>
	using namespace std ;
#else
	#include <iostream.h>
#endif
#include <string.h>
#include "PhoneNumber.h"

PhoneNumber::PhoneNumber( const PhoneNumber & phoneNum )
: numberString( phoneNum.numberString )
, stringLength( phoneNum.stringLength )
, currentIndex( phoneNum.currentIndex )
{
}

PhoneNumber & PhoneNumber::operator=( const PhoneNumber & phoneNum )
{
    if( this != &phoneNum )
    {
	numberString = phoneNum.numberString;
	stringLength = phoneNum.stringLength;
	currentIndex = phoneNum.currentIndex;
    }
    return *this;
}

PhoneNumber & PhoneNumber::operator=( const char *phoneNum ) 
{ 
	strcpy(numberString,phoneNum);
	stringLength = strlen(phoneNum); 
	currentIndex = 0; 
    return *this; 
} 

PhoneNumber::PhoneNumber( unsigned length )
{
// Tutorial info
// To fix the error found
// uncomment the if statement at the end of this function
    stringLength = length;
    currentIndex = 0;
    if(length > 0)
    	numberString = new char[length + 1];
    for(unsigned int index = 0; index < stringLength; index++)
    	numberString[index] = '\0';
    // if(length > 0)     
    numberString[length] = '\0';
}

void PhoneNumber::clearNumber( void )
{
    currentIndex = 0;
    for(unsigned int index = 0; index < stringLength; index++)
    	numberString[index] = '\0';
}

void PhoneNumber::removeDigit( void )
{
    if (isEmpty( )) throw IsEmpty( );
    if(--currentIndex < 0)
    	currentIndex = 0;
    numberString[currentIndex]=(char)0;
}

int PhoneNumber::addDigit( char digit )
{
    if (isFull( )) throw IsFull( );
    if(currentIndex < stringLength){
    	numberString[currentIndex++] = digit;
    	return 1;
    }
    return 0;
}

int PhoneNumber::isFull( void )
{
    return (currentIndex <= stringLength) ? 0 : 1;
}

int PhoneNumber::isEmpty( void )
{
    return (currentIndex == 0) ? 1 : 0;
}

int PhoneNumber::size( void )
{
    return currentIndex;
}

char PhoneNumber::operator[]( int i )
{
    if(i < 0 || i >= stringLength)
    	return '\0';
    else
    	return numberString[i];
}

PhoneNumber::~PhoneNumber( void )
{
    if(stringLength)
    delete [] numberString;
}
