

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#if defined(_WIN32) || defined(__GNUC__)
	#include <iostream>
	using namespace std ;
#else
	#include <iostream.h>
#endif
#include <stdlib.h>
#include <string.h>
#include "UmtsConnection.h"

#ifdef PROBES
#include "UmtsMsg.h"
#include "atlprobe.h" // to use TestRT probes _trace
#endif

void UmtsConnection::handle( tcpsck_return_t ret )
{
 if (ret==TCPSCK_ERROR)
  {
   tcpsck_return_t tmp=tcpsck_get_last_error();
   cerr <<"BaseStation:" << tcpsck_get_error_message(tmp) << endl;
   throw LostConnection(tmp);
  }
}


void UmtsConnection::processMessages()
{
  UmtsMsg *msg;
  UmtsMsg response;
  char buffer[100];
  int ret;

  response.command[0]=0;
  response.phoneNumber[0]=0;
  response.simCardId=0;
  response.baseStationId=0;

  if (tcpsck_data_ready(sck,0))
  {
   ret=tcpsck_recv(sck,buffer,100);
   handle(ret);
// Tutorial info
// To remove the memory leak
// Scroll down to the end of this function and
// Uncomment the call to the free function
   UmtsMsg_decode(&msg,buffer);

#ifdef PROBES
// probe trace to generate the equivalent script to the execution
   atl_send_trace(base_ctx,decode,msg,UmtsMsg,request);
#endif

   if (strcmp(msg->command,cmd_connection_request)==0)
   {
      strcpy(response.command,cmd_connection_established);
      response.baseStationId=6796;
   }
   else if (strcmp(msg->command,cmd_call)==0)
   {
    response.simCardId=msg->simCardId;
    response.baseStationId=msg->baseStationId;
    num.clearNumber();
    num=msg->phoneNumber;
// Tutorial info
// To cover the following block
// Run again the MobilePhone application
// And Dial the number "5550001"
    if (strcmp(msg->phoneNumber,"5550001")==0)
     {
      strcpy(response.command,cmd_accepted);
     }
    else
     {
      strcpy(response.command,cmd_busy);
     }
    strcpy(response.phoneNumber,num.theNumber());
   }
   else
   {
	serverShutdown=1;
   }

#ifdef PROBES
 // probe trace to generate the equivalent script to the execution */
   atl_recv_trace(base_ctx,decode,&response,UmtsMsg,answer);
#endif

   UmtsMsg_code(&response,buffer);
   ret=tcpsck_send(sck,buffer,strlen(buffer));
// Tutorial info
// To remove the memory leak
// Uncomment the following line of code
// free(msg);
   handle(ret);
  }
}
