

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



package baseStation;

public class UmtsMsg
{
	static public String CNX_REQUEST="CNX RQ";
	static public String CNX_ACCEPTED="CNX OK";
	static public String NETWORK_BUSY="NET BUSY";
	static public String DECONN_REQUEST="DECONN RQ";
	static public String DECONN_ACCEPTED="DECONN OK";
	static public String CALL="CALL";
	static public String ACCEPTED="ACCEPTED";
	static public String BUSY="BUSY";
	static public String UNREACHABLE="UNREACH";
	static public String END="END";
	static public String NYI="NYI";
	static public String SHUTDOWN="SHUTDOWN";

	private String _command;
	private PhoneNumber _phoneNumber;
	private int _simCardId;
	private int _baseStationId; 
 	 
	public UmtsMsg()
	{
		_phoneNumber=new PhoneNumber(10);
	}
 
	public String toString()
	{
		return(_command+" "+_phoneNumber+" "+_simCardId+" "+_baseStationId);
	}
  
	public void setCommand(String cmd)
	{
		_command=cmd;
	}
 	
	public String getCommand()
	{
		return(_command);
	}
	
	public void setPhoneNumber(String phoneNumber)
	{
	  try
	  {
		int i;
		_phoneNumber.cleanNumber();
		for (i=0;i<phoneNumber.length();i++)
		{
 			_phoneNumber.addDigit(Integer.parseInt(phoneNumber.substring(i,i+1)));
        }
      }
	  catch (Exception e)
	  {
	   // oops
	  }
	}
 	
	public String getPhoneNumber()
	{
		return(_phoneNumber.toString());
	}
 	
	public void setSimCardId(int simCardId)
	{
		_simCardId=simCardId;
	}
 	
	public int getSimCardId()
	{
		return(_simCardId);
	}
 	
	public int getBaseStationId()
	{
		return(_baseStationId);
	}
 	
	public void setBaseStationId(int baseStationId)
	{
		_baseStationId=baseStationId;
	}
 	
	public boolean isCmdConnectionRequest()
	{
		return(_command.equals(CNX_REQUEST));
	}
	public boolean isCmdConnectionEstablished()
	{
		return(_command.equals(CNX_ACCEPTED));
	}
	public boolean isCmdNetworkBusy()
	{
		return(_command.equals(NETWORK_BUSY));
	}
	public boolean isCmdDeconnectionRequest()
	{
		return(_command.equals(DECONN_REQUEST));
	}
	public boolean isCmdDeconnected()
	{
		return(_command.equals(DECONN_ACCEPTED));
	}
	public boolean isCmdCall()
	{
		return(_command.equals(CALL));
	}
	public boolean isCmdAccepted()
	{
		return(_command.equals(ACCEPTED));
	}
	public boolean isCmdBusy()
	{
		return(_command.equals(BUSY));
	}
	public boolean isCmdUnreachable()
	{
		return(_command.equals(UNREACHABLE));
	}
	public boolean isCmdEndOfCall()
	{
		return(_command.equals(END));
	}
	public boolean isCmdNYI()
	{
		return(_command.equals(NYI));
	}
	public boolean isCmdShutdown()
	{
		return(_command.equals(SHUTDOWN));
	}
};
