////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2010 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
////////////////////////////////////////////////////////////////////////////////

import junit.framework.*;
import src.divide.Divide;

public class TestDivide extends TestCase {
    public TestDivide()  {
        super("TestDivide");
    }

    public TestDivide(String name)  {
        super(name);
    }

    public Divide obj = null; //Object under test
    protected void setUp() throws Exception {
        try{

            obj = new Divide();
            // ...
        }
        catch(Throwable e){
            fail(e.toString());
        }
    }

    protected void tearDown() throws Exception {
        // ...
        obj = null;
    }

    public void testdivide_bothZero() {

        try{
            int v1 = 0;
            int v2 = 0;

            double ret = obj.divide(v1, v2);

            StubSequence testof = new StubSequence(this);
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.ENTER) ;
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.EXIT) ;
            verifyEquals("Test src.testing.Testing.valid is called",TestSynchroStub.isSeqRespected(testof),true);
            verifyEquals("Test single sequence",TestSynchroStub.areStubfail(this),false);

            verifyEquals(ret,0.0);
        }
        catch(Throwable e){
            fail(e.toString());

        }
    }

    public void testdivide_OneZero() {

        try{
            int v1 = 1;
            int v2 = 0;
            double ret = obj.divide(v1, v2);

            StubSequence testof = new StubSequence(this);
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.ENTER) ;
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.EXIT) ;
            verifyEquals("Test src.testing.Testing.valid is called",TestSynchroStub.isSeqRespected(testof),true);

            verifyEquals(ret,0.0);

        }
        catch(Throwable e){
            fail(e.toString());

        }
    }

    public void testdivide_ZeroOne() {

        try{
            int v1 = 0;
            int v2 = 1;
            double ret = obj.divide(v1, v2);

            StubSequence testof = new StubSequence(this);
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.ENTER) ;
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.EXIT) ;
            verifyEquals("Test src.testing.Testing.valid is called",TestSynchroStub.isSeqRespected(testof),true);

            verifyEquals(ret,0.0);

        }
        catch(Throwable e){
            fail(e.toString());

        }
    }

    public void testdivide_OneOne() {

        try{
            int v1 = 1;
            int v2 = 1;
            double ret = obj.divide(v1, v2);

            StubSequence testof = new StubSequence(this);
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.ENTER) ;
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.EXIT) ;
            verifyEquals("Test src.testing.Testing.valid is called",TestSynchroStub.isSeqRespected(testof),true);

            verifyEquals(ret,1.0);

        }
        catch(Throwable e){
            fail(e.toString());

        }
    }

    public void testdivide_TenFive() {

        try{
            int v1 = 10;
            int v2 = 5;
            double ret = obj.divide(v1, v2);

            StubSequence testof = new StubSequence(this);
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.ENTER) ;
            testof.addEltToSequence( new src.testing.Testing().getClass() , "valid(int)", StubInfo.EXIT) ;
            verifyEquals("Test src.testing.Testing.valid is called",TestSynchroStub.isSeqRespected(testof),true);
            verifyEquals("Test single sequence",TestSynchroStub.areStubfail(this),true);

            verifyEquals(ret,2.0);

        }
        catch(Throwable e){
            fail(e.toString());

        }
    }

}




